function[sys,x0,str,ts]=adp(t,x,u,flag)
switch flag,
    case 0,
        [sys,x0,str,ts]=mdlInitializeSizes;
    case 1,
        sys=mdlDerivatives(t,x,u);
    case 3,
        sys=mdlOutputs(t,x,u);
    case {2,4,9}
        sys=[];
    otherwise
        error(['Unhandled flag=',num2str(flag)]);
end

function[sys,x0,str,ts]=mdlInitializeSizes

sizes=simsizes;
sizes.NumContStates  = 10;
sizes.NumDiscStates  = 0;
sizes.NumOutputs     = 10;
sizes.NumInputs      = 50;
sizes.DirFeedthrough = 1;
sizes.NumSampleTimes = 0;
sys = simsizes(sizes);
x0=[0 0 0 0 0 0 0 0 0 0];%干扰观测初值为0；
str = [];
ts  = [];

function sys=mdlDerivatives(t,x,u)
%%%%输入
x1=[u(1);u(2);u(3);u(4);u(5);u(6);u(7);u(8);u(9);u(10)];                 %实际角度θ φ
x2=[u(11);u(12);u(13);u(14);u(15);u(16);u(17);u(18);u(19);u(20)];        %实际角速度dθ dφ
y1d=[u(21);u(22);u(23);u(24);u(25);u(26);u(27);u(28);u(29);u(30)];        %期望角度
y2d=[u(31);u(32);u(33);u(34);u(35);u(36);u(37);u(38);u(39);u(40)];        %期望角速度
y3d=[u(41);u(42);u(43);u(44);u(45);u(46);u(47);u(48);u(49);u(50)];       %期望角加速度

%%%%%%%%%%%%%%%控制参数%%%%%%%%%%%%%%%%
% c11=[1.8 1.8 0.2 0.2 0.2 0.2 0.2 0.2 0.2 0.2];
% c1=diag(c11);
% gama11=[1000 100 10 10 10 10 10 10 10 10];
% gama=diag(gama11);
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% e1=y1d-x1;%跟踪误差
% e2=y2d-x2;
% s=c1*e1+e2;%滑模面
% %%%%%%%%%%%%%%%%自适应补偿干扰%%%%%%%%
% dd=gama*s;%[6*1]

k11=[10 10 10 10 10 10 10 10 10 10];
k1=diag(k11);
gama11=[0.2 .2 .2 .2 .2 .2 .2 .2 .2 .2];
gama=diag(gama11);
%%%%%%%%%%%%%%%控制参数%%%%%%%%%%%%%%%%
e1=y1d-x1;%跟踪误差
% de1=y2d-x2;
rou=1*exp(-2*t)+0.01;
% drou=-20*exp(-2*t);
Lk=pi*(e1'*e1)/(2*rou*rou);
K1=2;
z1k=y2d+2*K1*rou*rou*sin(Lk)*cos(Lk)*e1/(pi*e1'*e1)-K1*e1+k1*cos(Lk)*cos(Lk)*e1;
e2=z1k-x2;
dd=gama*e2;%[2*1]

sys(1)=dd(1);
sys(2)=dd(2);
sys(3)=dd(3);
sys(4)=dd(4);
sys(5)=dd(5);
sys(6)=dd(6);
sys(7)=dd(7);
sys(8)=dd(8);
sys(9)=dd(9);
sys(10)=dd(10);

function sys=mdlOutputs(t,x,u)
sys(1)=x(1);
sys(2)=x(2);
sys(3)=x(3);
sys(4)=x(4);
sys(5)=x(5);
sys(6)=x(6);
sys(7)=x(7);
sys(8)=x(8);
sys(9)=x(9);
sys(10)=x(10);
