%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%本程序实现了擦洗臂运动学逆解
%方法采用Godage团队运动学模型，该程序进行复现
%单位：米，秒
% clc;
% clear;
% close all;
syms l1 l2 l3 l4 l5 l6 l7 l8 j real;
% syms d k real;
% L=0.15;   %气动肌肉最小长度
d=0.06;   %间隔盘长度
lim=0.06;   %两间隔盘距离
lmax=0.3625;   %气动肌肉最大长度
lmin=0.3125;  
% l1=0.3625; 
% l2=0.3575; 
% l3=0.3625; 
% l4=0.3625;
% l5=0.3625; 
% l6=0.3635; 
% l7=0.3625;
% l8=0.3625;
k=1;
g=9.80665;
x= 0.01;
y= 0;
z=0.3225;
m33=0.9931  ;
% x,y不等于0
fai=atan(y/x);      %偏转角度
% theta=acos(m33);    %弯曲角度
% R=F2/(1-cos(theta)); %曲率半径
theta=2*atan(x/(z*cos(fai)));
R=z/sin(theta);

K=1/R;          %曲率
L=theta*R;      %弧长

% l1=2*sin(theta/2)*(R-d*cos(fai));
% l2=2*sin(theta/2)*(R+d*sin(fai));
% l3=2*sin(theta/2)*(R+d*cos(fai));
% l4=2*sin(theta/2)*(R-d*sin(fai));

l1=theta*R-theta*d*cos(fai);
l2=theta*R-theta*d*sin(fai);
l3=theta*R+theta*d*cos(fai);
l4=theta*R+theta*d*sin(fai);

if l1>lmax||l2>lmax||l3>lmax||l4>lmax||l1<lmin||l2<lmin||l3<lmin||l4<lmin
    j=0;
end

% F1=x/cos(atan(y/x));
% F2=y/sin(atan(y/x));
% alfa=atan(z/F1);
% theta=pi/2-alfa/2;  %弯曲角度
% R=z/sin(theta); %曲率半径
