function[sys,x0,str,ts]=dtheta(t,x,u,flag)
switch flag,
    case 0,
        [sys,x0,str,ts]=mdlInitializeSizes;
    case 3,
        sys=mdlOutputs(t,x,u);
    case {2,4,9}
        sys=[];
    otherwise
        error(['Unhandled flag=',num2str(flag)]);
end

function[sys,x0,str,ts]=mdlInitializeSizes

sizes=simsizes;
sizes.NumContStates  = 0;
sizes.NumDiscStates  = 0;
sizes.NumOutputs     = 210;
sizes.NumInputs      = 50;
sizes.DirFeedthrough = 1;
sizes.NumSampleTimes = 0;
sys = simsizes(sizes);
x0=[];
str = [];
ts  = [];

function sys=mdlOutputs(t,x,u)
%%%%输入
x1=[u(1);u(2);u(3);u(4);u(5);u(6);u(7);u(8);u(9);u(10)];                 %实际角度θ φ
x2=[u(11);u(12);u(13);u(14);u(15);u(16);u(17);u(18);u(19);u(20)];        %实际角速度dθ dφ
y1d=[u(21);u(22);u(23);u(24);u(25);u(26);u(27);u(28);u(29);u(30)];        %期望角度
y2d=[u(31);u(32);u(33);u(34);u(35);u(36);u(37);u(38);u(39);u(40)];        %期望角速度
y3d=[u(41);u(42);u(43);u(44);u(45);u(46);u(47);u(48);u(49);u(50)];       %期望角加速度
%%%%%%%%%%%%%%%控制参数%%%%%%%%%%%%%%%%
% c11=[1.8 1.8 0.2 0.2 0.2 0.2 0.2 0.2 0.2 0.2];
% c1=diag(c11);
% qq=[0.75 0.75 0.5 0.5 0.5 0.5 0.5 0.5 0.5 0.5];
% q=diag(qq);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% e1=y1d-x1;%跟踪误差
% e2=y2d-x2;
% s=c1*e1+e2;%须保证当t=0时，s=0；[6*1]
% fai=[c1*e2+y3d;x2+s;1];%已知状态部分[13*1]
% dtheta=q*s*fai';%[6*13]

%%%%%%%%%%%%%%%控制参数%%%%%%%%%%%%%%%%
k11=[10 10 10 10 10 10 10 10 10 10];
k1=diag(k11);
qq=[0.5 0.5 0.5 0.5 0.5 0.5 0.5 0.5 0.5 0.5];
q=diag(qq);
e1=y1d-x1;%跟踪误差
de1=y2d-x2;
rou=1*exp(-2*t)+0.01;
drou=-2*exp(-2*t);
Lk=pi*(e1'*e1)/(2*rou*rou);
K1=2;
z1k=y2d+2*K1*rou*rou*sin(Lk)*cos(Lk)*e1/(pi*e1'*e1)-K1*e1+k1*cos(Lk)*cos(Lk)*e1;
e2=z1k-x2;
A=de1'*e1+e1'*de1;
B=0.5*pi*(A*rou-2*e1'*e1*drou)/(rou*rou*rou);
I1=2*rou*drou*e1*sin(2*Lk)/(e1'*e1)+rou*rou*((de1*e1'*e1-e1*A)*sin(2*Lk)/((e1'*e1)*(e1'*e1))+2*e1*cos(2*Lk)*B/(e1'*e1));
I2=-2*k1*cos(Lk)*sin(Lk)*B*e1+k1*cos(Lk)*cos(Lk)*de1;
dz1k=y3d-K1*de1+K1*I1/pi+I2;
% dz1k=y3d+(400*exp(-3*t))/(10*exp(-2*t)+1/100)^2-(20*exp(-t))/(10*exp(-2*t)+1/100)+k1*de1*cos((pi*exp(2*t))/((20*exp(-2*t)+1/50)*(10*exp(-2*t)+1/100)))^2+(800*sin((pi*exp(2*t))/((20*exp(-2*t)+1/50)*(10*exp(-2*t)+1/100)))*exp(-5*t)*cos((pi*exp(2*t))/((20*exp(-2*t)+1/50)*(10*exp(-2*t)+1/100))))/pi+(120*sin((pi*exp(2*t))/((20*exp(-2*t)+1/50)*(10*exp(-2*t)+1/100)))*exp(-3*t)*cos((pi*exp(2*t))/((20*exp(-2*t)+1/50)*(10*exp(-2*t)+1/100)))*(10*exp(-2*t)+1/100))/pi-(40*exp(-3*t)*cos((pi*exp(2*t))/((20*exp(-2*t)+1/50)*(10*exp(-2*t)+1/100)))^2*(10*exp(-2*t)+1/100)*((20*pi)/((20*exp(-2*t)+1/50)*(10*exp(-2*t)+1/100)^2)+(40*pi)/((20*exp(-2*t)+1/50)^2*(10*exp(-2*t)+1/100))+(2*pi*exp(2*t))/((20*exp(-2*t)+1/50)*(10*exp(-2*t)+1/100))))/pi-2*k1*sin((pi*exp(2*t))/((20*exp(-2*t)+1/50)*(10*exp(-2*t)+1/100)))*de1*cos((pi*exp(2*t))/((20*exp(-2*t)+1/50)*(10*exp(-2*t)+1/100)))*((20*pi)/((20*exp(-2*t)+1/50)*(10*exp(-2*t)+1/100)^2)+(40*pi)/((20*exp(-2*t)+1/50)^2*(10*exp(-2*t)+1/100))+(2*pi*exp(2*t))/((20*exp(-2*t)+1/50)*(10*exp(-2*t)+1/100)))+(40*sin((pi*exp(2*t))/((20*exp(-2*t)+1/50)*(10*exp(-2*t)+1/100)))^2*exp(-3*t)*(10*exp(-2*t)+1/100)*((20*pi)/((20*exp(-2*t)+1/50)*(10*exp(-2*t)+1/100)^2)+(40*pi)/((20*exp(-2*t)+1/50)^2*(10*exp(-2*t)+1/100))+(2*pi*exp(2*t))/((20*exp(-2*t)+1/50)*(10*exp(-2*t)+1/100))))/pi;

fai=[dz1k;z1k;1];
dtheta=q*e2*fai';%[5*11]

%dtheta1
sys(1)=dtheta(1,1);sys(2)=dtheta(1,2);sys(3)=dtheta(1,3);sys(4)=dtheta(1,4);sys(5)=dtheta(1,5);
sys(6)=dtheta(1,6);sys(7)=dtheta(1,7);sys(8)=dtheta(1,8);sys(9)=dtheta(1,9);sys(10)=dtheta(1,10);
sys(11)=dtheta(1,11);sys(12)=dtheta(1,12);sys(13)=dtheta(1,13);sys(14)=dtheta(1,14);
sys(15)=dtheta(1,15);sys(16)=dtheta(1,16);sys(17)=dtheta(1,17);sys(18)=dtheta(1,18);
sys(19)=dtheta(1,19);sys(20)=dtheta(1,20);sys(21)=dtheta(1,21);
%dtheta2
sys(22)=dtheta(2,1);sys(23)=dtheta(2,2);sys(24)=dtheta(2,3);sys(25)=dtheta(2,4);sys(26)=dtheta(2,5);
sys(27)=dtheta(2,6);sys(28)=dtheta(2,7);sys(29)=dtheta(2,8);sys(30)=dtheta(2,9);sys(31)=dtheta(2,10);
sys(32)=dtheta(2,11);sys(33)=dtheta(2,12);sys(34)=dtheta(2,13);sys(35)=dtheta(2,14);
sys(36)=dtheta(2,15);sys(37)=dtheta(2,16);sys(38)=dtheta(2,17);sys(39)=dtheta(2,18);
sys(40)=dtheta(2,19);sys(41)=dtheta(2,20);sys(42)=dtheta(2,21);
%dtheta3
sys(43)=dtheta(3,1);sys(44)=dtheta(3,2);sys(45)=dtheta(3,3);sys(46)=dtheta(3,4);sys(47)=dtheta(3,5);
sys(48)=dtheta(3,6);sys(49)=dtheta(3,7);sys(50)=dtheta(3,8);sys(51)=dtheta(3,9);sys(52)=dtheta(3,10);
sys(53)=dtheta(3,11);sys(54)=dtheta(3,12);sys(55)=dtheta(3,13);sys(56)=dtheta(3,14);
sys(57)=dtheta(3,15);sys(58)=dtheta(3,16);sys(59)=dtheta(3,17);sys(60)=dtheta(3,18);
sys(61)=dtheta(3,19);sys(62)=dtheta(3,20);sys(63)=dtheta(3,21);
%dtheta4
sys(64)=dtheta(4,1);sys(65)=dtheta(4,2);sys(66)=dtheta(4,3);sys(67)=dtheta(4,4);sys(68)=dtheta(4,5);
sys(69)=dtheta(4,6);sys(70)=dtheta(4,7);sys(71)=dtheta(4,8);sys(72)=dtheta(4,9);sys(73)=dtheta(4,10);
sys(74)=dtheta(4,11);sys(75)=dtheta(4,12);sys(76)=dtheta(4,13);sys(77)=dtheta(4,14);
sys(78)=dtheta(4,15);sys(79)=dtheta(4,16);sys(80)=dtheta(4,17);sys(81)=dtheta(4,18);
sys(82)=dtheta(4,19);sys(83)=dtheta(4,20);sys(84)=dtheta(4,21);
%dtheta5
sys(85)=dtheta(5,1);sys(86)=dtheta(5,2);sys(87)=dtheta(5,3);sys(88)=dtheta(5,4);sys(89)=dtheta(5,5);
sys(90)=dtheta(5,6);sys(91)=dtheta(5,7);sys(92)=dtheta(5,8);sys(93)=dtheta(5,9);sys(94)=dtheta(5,10);
sys(95)=dtheta(5,11);sys(96)=dtheta(5,12);sys(97)=dtheta(5,13);sys(98)=dtheta(5,14);
sys(99)=dtheta(5,15);sys(100)=dtheta(5,16);sys(101)=dtheta(5,17);sys(102)=dtheta(5,18);
sys(103)=dtheta(5,19);sys(104)=dtheta(5,20);sys(105)=dtheta(5,21);
%dtheta6
sys(106)=dtheta(6,1);sys(107)=dtheta(6,2);sys(108)=dtheta(6,3);sys(109)=dtheta(6,4);sys(110)=dtheta(6,5);
sys(111)=dtheta(6,6);sys(112)=dtheta(6,7);sys(113)=dtheta(6,8);sys(114)=dtheta(6,9);sys(115)=dtheta(6,10);
sys(116)=dtheta(6,11);sys(117)=dtheta(6,12);sys(118)=dtheta(6,13);sys(119)=dtheta(6,14);
sys(120)=dtheta(6,15);sys(121)=dtheta(6,16);sys(122)=dtheta(6,17);sys(123)=dtheta(6,18);
sys(124)=dtheta(6,19);sys(125)=dtheta(6,20);sys(126)=dtheta(6,21);
%dtheta7
sys(127)=dtheta(7,1);sys(128)=dtheta(7,2);sys(129)=dtheta(7,3);sys(130)=dtheta(7,4);sys(131)=dtheta(7,5);
sys(132)=dtheta(7,6);sys(133)=dtheta(7,7);sys(134)=dtheta(7,8);sys(135)=dtheta(7,9);sys(136)=dtheta(7,10);
sys(137)=dtheta(7,11);sys(138)=dtheta(7,12);sys(139)=dtheta(7,13);sys(140)=dtheta(7,14);
sys(141)=dtheta(7,15);sys(142)=dtheta(7,16);sys(143)=dtheta(7,17);sys(144)=dtheta(7,18);
sys(145)=dtheta(7,19);sys(146)=dtheta(7,20);sys(147)=dtheta(7,21);
%dtheta8
sys(148)=dtheta(8,1);sys(149)=dtheta(8,2);sys(150)=dtheta(8,3);sys(151)=dtheta(8,4);sys(152)=dtheta(8,5);
sys(153)=dtheta(8,6);sys(154)=dtheta(8,7);sys(155)=dtheta(8,8);sys(156)=dtheta(8,9);sys(157)=dtheta(8,10);
sys(158)=dtheta(8,11);sys(159)=dtheta(8,12);sys(160)=dtheta(8,13);sys(161)=dtheta(8,14);
sys(162)=dtheta(8,15);sys(163)=dtheta(8,16);sys(164)=dtheta(8,17);sys(165)=dtheta(8,18);
sys(166)=dtheta(8,19);sys(167)=dtheta(8,20);sys(168)=dtheta(8,21);
%dtheta9
sys(169)=dtheta(9,1);sys(170)=dtheta(9,2);sys(171)=dtheta(9,3);sys(172)=dtheta(9,4);sys(173)=dtheta(9,5);
sys(174)=dtheta(9,6);sys(175)=dtheta(9,7);sys(176)=dtheta(9,8);sys(177)=dtheta(9,9);sys(178)=dtheta(9,10);
sys(179)=dtheta(9,11);sys(180)=dtheta(9,12);sys(181)=dtheta(9,13);sys(182)=dtheta(9,14);
sys(183)=dtheta(9,15);sys(184)=dtheta(9,16);sys(185)=dtheta(9,17);sys(186)=dtheta(9,18);
sys(187)=dtheta(9,19);sys(188)=dtheta(9,20);sys(189)=dtheta(9,21);
%dtheta10
sys(190)=dtheta(10,1);sys(191)=dtheta(10,2);sys(192)=dtheta(10,3);sys(193)=dtheta(10,4);sys(194)=dtheta(10,5);
sys(195)=dtheta(10,6);sys(196)=dtheta(10,7);sys(197)=dtheta(10,8);sys(198)=dtheta(10,9);sys(199)=dtheta(10,10);
sys(200)=dtheta(10,11);sys(201)=dtheta(10,12);sys(202)=dtheta(10,13);sys(203)=dtheta(10,14);
sys(204)=dtheta(10,15);sys(205)=dtheta(10,16);sys(206)=dtheta(10,17);sys(207)=dtheta(10,18);
sys(208)=dtheta(10,19);sys(209)=dtheta(10,20);sys(210)=dtheta(10,21);