%本程序实现了机械臂阻抗控制，实现了动态人机交互，属于间接力控方式
%Fd为人机静态平衡力，人为设定恒定或变化值，Fint为外力
%采用4-5阶龙格库塔方法求解微分方程（变步长），值为误差e，4阶方法提供候选解，5阶方法控制误差。
%期望轨迹-误差=修正后轨迹
tspan=[0 5];
e0=[0 0];
[t,x]=ode45('odefun',tspan,e0);
xx=x(:,1);
xy=x(:,2);
plot(t,x(:,1),'-o',t,x(:,2),'-*');
legend('y','y''');