function[sys,x0,str,ts]=sysinput(t,x,u,flag)
switch flag,
    case 0,
        [sys,x0,str,ts]=mdlInitializeSizes;
    case 3,
        sys=mdlOutputs(t,x,u);
    case {2,4,9}
        sys=[];
    otherwise
        error(['Unhandled flag=',num2str(flag)]);
end

function[sys,x0,str,ts]=mdlInitializeSizes

sizes=simsizes;
sizes.NumContStates  = 0;
sizes.NumDiscStates  = 0;
sizes.NumOutputs     = 30;
sizes.NumInputs      = 0;
sizes.DirFeedthrough = 0;
sizes.NumSampleTimes = 1;
sys = simsizes(sizes);
x0=[];
str = [];
ts  = [0 0];

%%%%%%%%%%%%%%%%%%%%期望轨迹部分%%%%%%%%%%%%%%%%%%%%%%%%
function sys=mdlOutputs(t,x,u)
%%%%%%%期望位置%%%%%%
%%%%Scala旋转关节%%%%%
x1d=sin(pi*t/50);
x2d=sin(pi*t/50);
%%%上端面%%%
x3d=0.2150-sin(pi*t/25)*0.05;
x4d=0.2150-sin(pi*t/25)*0.05;
x5d=0.2150-sin(pi*t/50)*0.05;
x6d=0.2150-sin(pi*t/50)*0.05;
%%%%下端面%%%%
x7d=0.2150-sin(pi*t/25)*0.05;
x8d=0.2150-sin(pi*t/25)*0.05;
x9d=0.2150-sin(pi*t/50)*0.05;
x10d=0.2150-sin(pi*t/50)*0.05;
%%%%%%%%期望速度%%%%%%%%%
%%%%Scala旋转关节%%%%%
dx1d=cos(pi*t/50)*pi/50;
dx2d=cos(pi*t/50)*pi/50;
%%%%上端面%%%%
dx3d=-cos(pi*t/25)*0.05*pi/25;
dx4d=-cos(pi*t/25)*0.05*pi/25;
dx5d=-cos(pi*t/50)*0.05*pi/50;
dx6d=-cos(pi*t/50)*0.05*pi/50;
%%%%下端面%%%%
dx7d=-cos(pi*t/25)*0.05*pi/25;
dx8d=-cos(pi*t/25)*0.05*pi/25;
dx9d=-cos(pi*t/50)*0.05*pi/50;
dx10d=-cos(pi*t/50)*0.05*pi/50;
%%%%%%%%%期望加速度%%%%%%%%%
%%%%Scala旋转关节%%%%%
ddx1d=-sin(pi*t/50)*pi*pi/50/50;
ddx2d=-sin(pi*t/50)*pi*pi/50/50;
%%%%上端面%%%%
ddx3d=sin(pi*t/25)*0.05*pi*pi/25/25;
ddx4d=sin(pi*t/25)*0.05*pi*pi/25/25;
ddx5d=sin(pi*t/50)*0.05*pi*pi/50/50;
ddx6d=sin(pi*t/50)*0.05*pi*pi/50/50;
%%%%下端面%%%%
ddx7d=sin(pi*t/25)*0.05*pi*pi/25/25;
ddx8d=sin(pi*t/25)*0.05*pi*pi/25/25;
ddx9d=sin(pi*t/50)*0.05*pi*pi/50/50;
ddx10d=sin(pi*t/50)*0.05*pi*pi/50/50;
%%%%%%%%%%%%%%%%%%%%阻抗控制部分%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%轨迹修正部分%%%%%%%%%%%%%%%%%%%%%%%%
h=0.5;
if t<h
rou1=(1-1*t/h)*(1-1*t/h)*(1-1*t/h);
% % rou1=(cos(pi*t/(2*h)))*(cos(pi*t/(2*h)))*(cos(pi*t/(2*h)));
else
rou1=0;
end

if t<h
rou2=t*(1-1*t/h)*(1-1*t/h)*(1-1*t/h);
% rou2=t*(cos(pi*t/(2*h)))*(cos(pi*t/(2*h)))*(cos(pi*t/(2*h)));
else
rou2=0;
end

y1d=x1d-rou1*(0-0)-rou2*(pi/50-0);
y2d=x2d-rou1*(0-0)-rou2*(pi/50-0);
y3d=x3d-rou1*(0.2150-0)-rou2*(-0.05*pi/25-0);
y4d=x4d-rou1*(0.2150-0)-rou2*(-0.05*pi/25-0);
y5d=x5d-rou1*(0.2150-0)-rou2*(-0.05*pi/50-0);
y6d=x6d-rou1*(0.2150-0)-rou2*(-0.05*pi/50-0);
y7d=x7d-rou1*(0.2150-0)-rou2*(-0.05*pi/25-0);
y8d=x8d-rou1*(0.2150-0)-rou2*(-0.05*pi/25-0);
y9d=x9d-rou1*(0.2150-0)-rou2*(-0.05*pi/50-0);
y10d=x10d-rou1*(0.2150-0)-rou2*(-0.05*pi/50-0);

dy1d=dx1d-rou1*(pi/50-0)-rou2*(0-0);
dy2d=dx2d-rou1*(pi/50-0)-rou2*(0-0);
dy3d=dx3d-rou1*(-0.05*pi/25-0)-rou2*(0-0);
dy4d=dx4d-rou1*(-0.05*pi/25-0)-rou2*(0-0);
dy5d=dx5d-rou1*(-0.05*pi/50-0)-rou2*(0-0);
dy6d=dx6d-rou1*(-0.05*pi/50-0)-rou2*(0-0);
dy7d=dx7d-rou1*(-0.05*pi/25-0)-rou2*(0-0);
dy8d=dx8d-rou1*(-0.05*pi/25-0)-rou2*(0-0);
dy9d=dx9d-rou1*(-0.05*pi/50-0)-rou2*(0-0);
dy10d=dx10d-rou1*(-0.05*pi/50-0)-rou2*(0-0);

ddy1d=ddx1d-rou1*(0-0)-rou2*(-pi*pi*pi/(50*50*50)-0);
ddy2d=ddx2d-rou1*(0-0)-rou2*(-pi*pi*pi/(50*50*50)-0);
ddy3d=ddx3d-rou1*(0-0)-rou2*(0.05*pi*pi*pi/15625-0);
ddy4d=ddx4d-rou1*(0-0)-rou2*(0.05*pi*pi*pi/15625-0);
ddy5d=ddx5d-rou1*(0-0)-rou2*(0.05*pi*pi*pi/125000-0);
ddy6d=ddx6d-rou1*(0-0)-rou2*(0.05*pi*pi*pi/125000-0);
ddy7d=ddx7d-rou1*(0-0)-rou2*(0.05*pi*pi*pi/15625-0);
ddy8d=ddx8d-rou1*(0-0)-rou2*(0.05*pi*pi*pi/15625-0);
ddy9d=ddx9d-rou1*(0-0)-rou2*(0.05*pi*pi*pi/125000-0);
ddy10d=ddx10d-rou1*(0-0)-rou2*(0.05*pi*pi*pi/125000-0);

% y1d=x1d-rou1*(sin(0+pi/5)-0)-rou2*(cos(0+pi/5)-0.1);
% y2d=x2d-rou1*(sin(0+2*pi/5)-0)-rou2*(cos(0+2*pi/5)-0.1);
% 
% dy1d=dx1d-rou1*(cos(0+pi/5)-0.1)-rou2*(-sin(0+pi/5)-0);
% dy2d=dx2d-rou1*(cos(0+2*pi/5)-0.1)-rou2*(-sin(0+2*pi/5)-0);
% 
% ddy1d=ddx1d-rou1*(-sin(0+pi/5)-0)-rou2*(-cos(0+pi/5)-0);
% ddy2d=ddx2d-rou1*(-sin(0+2*pi/5)-0)-rou2*(-cos(0+2*pi/5)-0);

% sys(1)=y1d;
% sys(2)=y2d;
% sys(3)=y3d;
% sys(4)=y4d;
% sys(5)=y5d;
% sys(6)=y6d;
% sys(7)=y7d;
% sys(8)=y8d;
% sys(9)=y9d;
% sys(10)=y10d;
% 
% sys(11)=dy1d;
% sys(12)=dy2d;
% sys(13)=dy3d;
% sys(14)=dy4d;
% sys(15)=dy5d;
% sys(16)=dy6d;
% sys(17)=dy7d;
% sys(18)=dy8d;
% sys(19)=dy9d;
% sys(20)=dy10d;
% 
% sys(21)=ddy1d;
% sys(22)=ddy2d;
% sys(23)=ddy3d;
% sys(24)=ddy4d;
% sys(25)=ddy5d;
% sys(26)=ddy6d;
% sys(27)=ddy7d;
% sys(28)=ddy8d;
% sys(29)=ddy9d;
% sys(30)=ddy10d;


sys(1)=y1d;
sys(2)=y2d;
sys(3)=y3d;
sys(4)=y4d;
sys(5)=y5d;
sys(6)=y6d;
sys(7)=y7d;
sys(8)=y8d;
sys(9)=y9d;
sys(10)=y10d;

sys(11)=dy1d;
sys(12)=dy2d;
sys(13)=dy3d;
sys(14)=dy4d;
sys(15)=dy5d;
sys(16)=dy6d;
sys(17)=dy7d;
sys(18)=dy8d;
sys(19)=dy9d;
sys(20)=dy10d;

sys(21)=ddy1d;
sys(22)=ddy2d;
sys(23)=ddy3d;
sys(24)=ddy4d;
sys(25)=ddy5d;
sys(26)=ddy6d;
sys(27)=ddy7d;
sys(28)=ddy8d;
sys(29)=ddy9d;
sys(30)=ddy10d;
